# Online Banking

## Description
This application is about Online Banking that allow user to look at the transaction table and account table.
Users can demonstrate transferring the money from one account to another account. 
Users also can see the graphs result from the transaction and account data.

Here is some screenshots from our application

- Main Menu: ![Main Menu](screenshots/main_menu.png)
- Transaction Table: ![Transaction Table](screenshots/table.png)
- Transfer Window: ![Transfer Window](screenshots/transfer.png)
- Show Graph: ![Show Graph](screenshots/graph.png)


## Class Diagram
![class diagram](images/class_diagram.png)

## Sequence Diagram
This is a sequence diagram when user want to transfer money to other bank account
![sequence diagram](images/sequence_diagram.png)

 ##OOP Design

##Design Pattern Used

## Graph Problem
My project is to build an app that allows people to transfer money to each other and 
also show the data collected from the people. The feature that uses graph algorithms is money transactions. 
The sender can enter the amount of money they want to transfer and the account of the receiver they want to send to 
then the app will check if the user has enough money to transfer or not, if the user has enough money the money will be 
transferred to the destination account. We model the transaction sequence problem as a graph problem as follows:

- There is a vertex for each bank account. Assume there are n bank accounts.
- There is a directed edge p → q if there is a transaction from one account to another account.
- The association value will be the amount of money transferred.
- We need to find the shortest distance from vertex A to vertex B.
- We can solve this problem using BreadthFirstSearch from vertex A, and output distance[B].
- The algorithm runs in O(V + E) = O(n) time.


 ## Running the Application

1. Clone this repository
2. Download conda from [conda] and install in your own operating system
3. Open terminal/command prompt
4. Go to the directory that the repository is placed
5. Type in the terminal/command prompt:
   - conda create --name my_env pandas jupyter numpy matplotlib seaborn
   - type "y" to confirm creation
6. conda activate my_env
7. Run command: python gui.py


## Other Information
- Packages
  - Pandas: for data manipulating
  - Matplotlib: for showing graphs
  - Seaborn: for showing graphs
  - PIL: for import image to GUI
  - TKInter: for creating GUI
  - datetime: for get and manipulate time
  - Jupyter: for create notebooks
  - Networkx: for creating network graph

[conda]: <https://docs.conda.io/projects/conda/en/latest/user-guide/install/index.html>
[Youtube]: <https://youtu.be/zvj94nsrGeQ>
[Main Menu]: <https://github.com/prog2022/project-napon2545/blob/main/screenshots/main_menu.jpg>
[Transaction Table]: <https://github.com/prog2022/project-napon2545/blob/main/screenshots/table.jpg>
[Transfer Window]: <https://github.com/prog2022/project-napon2545/blob/main/screenshots/transfer.jpg>
[Show Graph]: <https://github.com/prog2022/project-napon2545/blob/main/screenshots/graph.jpg>